regina::GluingPermSearcher< 4 > Class Template Reference
Census of Triangulations

A utility class for searching through all possible gluing permutation sets that correspond to a given pentachoron facet pairing. More...

`#include <census/gluingpermsearcher4.h>`

Inheritance diagram for regina::GluingPermSearcher< 4 >:

## Classes

struct | PentEdgeState
| A structure used to track equivalence classes of pentachoron edges as the gluing permutation set is constructed. More...
struct | PentTriangleState
| A structure used to track equivalence classes of pentachoron triangles as the gluing permutation set is constructed. More...

## Public Types

typedef void(* | Use) (const GluingPermSearcher< 4 > *, void *)
| A routine that can do arbitrary processing upon a set of gluing permutations. More...

## Public Member Functions

| GluingPermSearcher (const FacetPairing< 4 > *pairing, const FacetPairing< 4 >::IsoList *autos, bool orientableOnly, bool finiteOnly, GluingPermSearcher< 4 >::Use use, void *useArgs=0)
| Initialises a new search for gluing permutation sets. More...
| GluingPermSearcher (std::istream &in, GluingPermSearcher< 4 >::Use use, void *useArgs=0)
| Initialises a new search manager based on data read from the given input stream. More...
virtual | ~GluingPermSearcher ()
| Destroys this search manager and all supporting data structures. More...
virtual void | runSearch (long maxDepth=-1)
| Generates all possible gluing permutation sets that satisfy the current search criteria. More...
bool | completePermSet () const
| Determines whether this search manager holds a complete gluing permutation set or just a partially completed search state. More...
void | dumpTaggedData (std::ostream &out) const
| Dumps all internal data in a plain text format, along with a marker to signify which precise class the data belongs to. More...
virtual void | dumpData (std::ostream &out) const
| Dumps all internal data in a plain text format to the given output stream. More...
bool | inputError () const
| Was an error found during construction from an input stream? More...
unsigned | size () const
| Returns the total number of simplices under consideration. More...
const FacetPairing< dim > * | facetPairing () const
| Returns the specific pairing of simplex facets that this set of gluing permutations complements. More...
Perm< dim+1 > | gluingPerm (const FacetSpec< dim > &source) const
| Returns the gluing permutation associated with the given simplex facet. More...
Perm< dim+1 > | gluingPerm (unsigned simp, unsigned facet) const
| Returns the gluing permutation associated with the given simplex facet. More...
Triangulation< dim > * | triangulate () const
| Returns a newly created triangulation as modelled by this set of gluing permutations and the associated simplex facet pairing. More...

## Static Public Member Functions

static void | findAllPerms (const FacetPairing< 4 > *pairing, const FacetPairing< 4 >::IsoList *autos, bool orientableOnly, bool finiteOnly, GluingPermSearcher< 4 >::Use use, void *useArgs=0)
| The main entry routine for running a search for all gluing permutation sets that complement a given pentachoron facet pairing. More...
static GluingPermSearcher< 4 > * | bestSearcher (const FacetPairing< 4 > *pairing, const FacetPairing< 4 >::IsoList *autos, bool orientableOnly, bool finiteOnly, GluingPermSearcher< 4 >::Use use, void *useArgs=0)
| Constructs a search manager of the best possible class for the given search parameters. More...
static GluingPermSearcher< 4 > * | readTaggedData (std::istream &in, GluingPermSearcher< 4 >::Use use, void *useArgs=0)
| Creates a new search manager based on tagged data read from the given input stream. More...

## Static Public Attributes

static const char | dataTag_
| A character used to identify this class when reading and writing tagged data in text format. More...

## Protected Member Functions

bool | isCanonical () const
| Compares the current set of gluing permutations with its preimage under each automorphism of the underlying facet pairing, in order to see whether the current set is in canonical form (i.e., is lexicographically smallest). More...
bool | badTriangleLink (const FacetSpec< 4 > &facet) const
| Determines whether the permutations already constructed model a 4-manifold triangulation with a (2-dimensional) triangle identified with itself using a non-trivial rotation or reflection. More...
virtual char | dataTag () const
| Returns the character used to identify this class when storing tagged data in text format. More...
int | findTriangleClass (int triID) const
| Returns the representative of the equivalence class containing the given pentachoron triangle. More...
int | findTriangleClass (int triID, Perm< 3 > &twist) const
| Returns the representative of the equivalence class containing the given pentachoron triangle. More...
bool | mergeEdgeClasses ()
| Merges the classes of pentachoron edges as required by the new gluing made at stage orderElt of the search. More...
bool | mergeTriangleClasses ()
| Merges the classes of pentachoron triangles as required by the new gluing made at stage orderElt of the search. More...
void | splitEdgeClasses ()
| Splits the classes of pentachoron edges to mirror the undoing of the gluing at stage orderElt of the search. More...
void | splitTriangleClasses ()
| Splits the classes of pentachoron triangles to mirror the undoing of the gluing at stage orderElt of the search. More...
void | edgeBdryJoin (int edgeID, char end, int adjEdgeID, char twist)
| Signifies that the boundary edges supplied by the linking triangles for the two given pentachoron edges should be marked as adjacent. More...
void | edgeBdryFixAdj (int edgeID)
| Adjusts the bdryNext and bdryTwist arrays for nearby pentachoron edges, to ensure that these arrays are consistent with the bdryNext and bdryTwist arrays stored with the given pentachoron edge. More...
void | edgeBdryBackup (int edgeID)
| Copies the bdryNext and bdryTwist arrays to the bdryNextOld and bdryTwistOld arrays for the given pentachoron edge. More...
void | edgeBdryRestore (int edgeID)
| Copies the bdryNextOld and bdryTwistOld arrays to the bdryNext and bdryTwist arrays for the given pentachoron edge. More...
void | edgeBdryNext (int edgeID, int pent, int edge, int bdryFacet, int next[2], char twist[2])
| Assuming the given edge of the linking triangle for the given pentachoron edge lies on the boundary of the link, this routine identifies the adjacent boundary edges of the link in each direction. More...
bool | edgeBdryLength1 (int edgeID)
| Determines whether one of the edges of the linking triangle for the given pentachoron edge in fact forms an entire one-edge boundary component of the overall 4-manifold edge link. More...
bool | edgeBdryLength2 (int edgeID1, int edgeID2)
| Determines whether edges of the linking triangles for each of the given pentachoron edges combine to form an entire two-edge boundary component of the overall 4-manifold edge link, with one edge from each triangle. More...
void | edgeBdryConsistencyCheck ()
| Runs a number of tests on all pentachoron edges to locate consistency errors in the bdryEdges, bdryNext and bdryTwist members of the PentEdgeState class. More...
void | edgeBdryDump (std::ostream &out)
| Dumps a summary of bdryNext, bdryTwist and bdryEdges for every edge of every pentachoron to the given output stream. More...
int & | permIndex (const FacetSpec< dim > &source)
| Returns the index into array Perm<dim+1>::Sn_1 describing how the the given facet is joined to its partner. More...
int & | permIndex (unsigned simp, unsigned facet)
| Returns the index into array Perm<dim+1>::Sn_1 describing how the the given facet is joined to its partner. More...
const int & | permIndex (const FacetSpec< dim > &source) const
| Returns the index into array Perm<dim+1>::Sn_1 describing how the the given facet is joined to its partner. More...
const int & | permIndex (unsigned simp, unsigned facet) const
| Returns the index into array Perm<dim+1>::Sn_1 describing how the the given facet is joined to its partner. More...
int | gluingToIndex (const FacetSpec< dim > &source, const Perm< dim+1 > &gluing) const
| Returns the index into array Perm<dim+1>::Sn_1 corresponding to the given gluing permutation from the given facet to its partner. More...
int | gluingToIndex (unsigned simp, unsigned facet, const Perm< dim+1 > &gluing) const
| Returns the index into array Perm<dim+1>::Sn_1 corresponding to the given gluing permutation from the given facet to its partner. More...
Perm< dim+1 > | indexToGluing (const FacetSpec< dim > &source, int index) const
| Returns the gluing permutation from the given facet to its partner that corresponds to the given index into array Perm<dim+1>::Sn_1. More...
Perm< dim+1 > | indexToGluing (unsigned simp, unsigned facet, int index) const
| Returns the gluing permutation from the given facet to its partner that corresponds to the given index into array Perm<dim+1>::Sn_1. More...

## Protected Attributes

const FacetPairing< 4 >::IsoList * | autos_
| The set of isomorphisms that define equivalence of gluing permutation sets. More...
bool | autosNew_
| Did we create the isomorphism list autos_ ourselves (in which case we must destroy it also)? More...
bool | orientableOnly_
| Are we only searching for gluing permutations that correspond to orientable triangulations? More...
bool | finiteOnly_
| Are we only searching for gluing permutations that correspond to finite (non-ideal) triangulations? More...
GluingPermSearcher< 4 >::Use | use_
| A routine to call each time a gluing permutation set is found during the search. More...
void * | useArgs_
| Additional user-supplied data to be passed as the second argument to the use_ routine. More...
bool | started_
| Has the search started yet? This helps distinguish between a new search and the resumption of a partially completed search. More...
int * | orientation_
| Keeps track of the orientation of each pentachoron in the underlying triangulation. More...
FacetSpec< 4 > * | order_
| Describes the order in which gluing permutations are assigned to pentachoron facets. More...
int | orderSize_
| The total number of edges in the facet pairing graph, i.e., the number of elements of interest in the order_[] array. More...
int | orderElt_
| Marks which element of order_[] we are currently examining at this stage of the search. More...
unsigned | nEdgeClasses_
| The number of equivalence classes of identified pentachoron edges. More...
PentEdgeState * | edgeState_
| Used for tracking equivalence classes of identified pentachoron edges. More...
int * | edgeStateChanged_
| Tracks the way in which the edgeState_[] array has been updated over time. More...
unsigned | nTriangleClasses_
| The number of equivalence classes of identified pentachoron triangles. More...
PentTriangleState * | triState_
| Used for tracking equivalence classes of identified pentachoron triangles. More...
int * | triStateChanged_
| Tracks the way in which the triState_[] array has been updated over time. More...
const FacetPairing< dim > * | pairing_
| The facet pairing that this permutation set complements. More...
int * | permIndices_
| The index into array Perm<dim+1>::Sn_1 describing how each simplex facet is glued to its partner. More...
bool | inputError_
| Has an error occurred during construction from an input stream? More...

## Static Protected Attributes

static const int | edgeLinkNextFacet [10][5]
| Maintains an ordering of the three pentachoron facets surrounding an edge in a pentachoron. More...
static const int | edgeLinkPrevFacet [10][5]
| Provides backwards links for the ordering described by edgeLinkNextFacet. More...

## Detailed Description

### template<>
class regina::GluingPermSearcher< 4 >

A utility class for searching through all possible gluing permutation sets that correspond to a given pentachoron facet pairing.

Subclasses of GluingPermSearcher<4> correspond to specialised (and heavily optimised) search algorithms that may be used in sufficiently constrained scenarios. The main class GluingPermSearcher<4> offers a default (but slower) search algorithm that may be used in more general contexts.

The simplest way of performing a search through all possible gluing permutations is by calling the static method findAllPerms(). This will examine the search parameters and ensure that the best possible algorithm is used. For finer control over the program flow, the static method bestSearcher() can be used to create a search manager of the most suitable class and then runSearch() can be called on this object directly. For absolute control, a specific algorithm can be forced by explicitly constructing an object of the corresponding class (and again calling runSearch() on that object directly).

The search algorithm used by this base class employs modified union-find structures for both triangle and edge equivalence classes to prune searches that are guaranteed to lead to invalid triangles or edges. This is a 4-dimensional analogue to the algorithms described in "Enumeration of non-orientable 3-manifolds using face-pairing graphs and union-find", Benjamin A. Burton, Discrete Comput. Geom. 38 (2007), no. 3, 527–571.

Note that this class derives from GluingPerms<4>. The search will involve building and repeatedly modifying the inherited GluingPerms<4> data in-place.

Python:
  Not present.

## Member Typedef Documentation

## Use

typedef void(* regina::GluingPermSearcher< 4 >::Use) (const GluingPermSearcher< 4 > *, void *)

A routine that can do arbitrary processing upon a set of gluing permutations.

Such routines are used to process permutation sets that are found when running census-building routines such as findAllPerms().

The first parameter passed will be a set of gluing permutations (as this class derives from GluingPerms<4>). This set of gluing permutations must not be deallocated by this routine, since it may be used again later by the caller. The second parameter may contain arbitrary data; typically this will be the data passed to the relevant search routine, such as findAllPerms() or the GluingPermSearcher class constructor.

Note that the first parameter passed might be `null` to signal that gluing permutation generation has finished.

## Constructor & Destructor Documentation

## GluingPermSearcher() [1/2]

regina::GluingPermSearcher< 4 >::GluingPermSearcher | ( | const FacetPairing< 4 > * | pairing,
|  | const FacetPairing< 4 >::IsoList * | autos,
|  | bool | orientableOnly,
|  | bool | finiteOnly,
|  | GluingPermSearcher< 4 >::Use | use,
|  | void * | useArgs = `0`
| ) |  |

Initialises a new search for gluing permutation sets.

The search is started by calling runSearch(). Note that the static method findAllPerms() handles both construction and searching, and is the preferred entry point for end users.

The arguments to this constructor describe the search parameters in detail, as well as what should be done with each gluing permutation set that is found.

The appropriate use of parameters orientableOnly and finiteOnly can significantly speed up the permutation set generation. For some combinations of these parameters entirely different algorithms are used.

Note that even if finiteOnly is set to `true`, some ideal triangulations might still slip through the net (since the full vertex links are not always constructed). However, setting finiteOnly to `true` will allow the census algorithm to take shortcuts and therefore run faster. The resulting triangulations may be tested for finiteness (and other properties) by calling triangulate().

Precondition
  The given facet pairing is connected, i.e., it is possible to reach any pentachoron from any other pentachoron via a series of matched facet pairs.
  The given facet pairing is in canonical form as described by FacetPairing<4>::isCanonical(). Note that all facet pairings constructed by FacetPairing<4>::findAllPairings() are of this form.

Parameters

  pairing | the specific pairing of pentachoron facets that the generated permutation sets will complement.

  autos

  the collection of isomorphisms that define equivalence of permutation sets. These are used by runSearch(), which produces each permutation set precisely once up to equivalence. These isomorphisms must all be automorphisms of the given facet pairing, and will generally be the set of all such automorphisms. This parameter may be 0, in which case the set of all automorphisms of the given facet pairing will be generated and used.

  orientableOnly | `true` if only gluing permutations corresponding to orientable triangulations should be generated, or `false` if no such restriction should be imposed.
  finiteOnly | `true` if only gluing permutations corresponding to finite (non-ideal) triangulations are required, or `false` if there is no such requirement. Note that regardless of this value, some ideal triangulations might still be produced; see the notes above for details.
  use | the function to call upon each permutation set that is found. The first parameter passed to this function will be a gluing permutation set. The second parameter will be parameter useArgs as was passed to this routine.
  useArgs | the pointer to pass as the final parameter for the function use which will be called upon each permutation set found.

## GluingPermSearcher() [2/2]

regina::GluingPermSearcher< 4 >::GluingPermSearcher | ( | std::istream & | in,
|  | GluingPermSearcher< 4 >::Use | use,
|  | void * | useArgs = `0`
| ) |  |

Initialises a new search manager based on data read from the given input stream.

This may be a new search or a partially completed search.

This routine reads data in the format written by dumpData(). If you wish to read data whose precise class is unknown, consider using dumpTaggedData() and readTaggedData() instead.

If the data found in the input stream is invalid or incorrectly formatted, the routine inputError() will return `true` but the contents of this object will be otherwise undefined.

Warning
  The data format is liable to change between Regina releases. Data in this format should be used on a short-term temporary basis only.

Parameters

  in | the input stream from which to read.
  use | as for the main GluingPermSearcher<4> constructor.
  useArgs | as for the main GluingPermSearcher<4> constructor.

## ~GluingPermSearcher()

virtual regina::GluingPermSearcher< 4 >::~GluingPermSearcher | ( |  | ) |

virtual

Destroys this search manager and all supporting data structures.

## Member Function Documentation

## badTriangleLink()

bool regina::GluingPermSearcher< 4 >::badTriangleLink | ( | const FacetSpec< 4 > & | facet | ) | const

protected

Determines whether the permutations already constructed model a 4-manifold triangulation with a (2-dimensional) triangle identified with itself using a non-trivial rotation or reflection.

Tests that do not refer to the gluing permutation for the given pentachoron facet will not be run.

This routine is not fussy about the order in which gluing permutations are selected, as long as permutations not yet selected have the corresponding element of permIndices[] set to -1.

Parameters

  facet | the specific pentachoron facet upon which tests will be based.

Returns
  `true` if the permutations under construction will lead to a triangle identified with itself using a non-trivial rotation or reflection, or `false` if no such triangle is found.

## bestSearcher()

static GluingPermSearcher<4>* regina::GluingPermSearcher< 4 >::bestSearcher | ( | const FacetPairing< 4 > * | pairing,
|  | const FacetPairing< 4 >::IsoList * | autos,
|  | bool | orientableOnly,
|  | bool | finiteOnly,
|  | GluingPermSearcher< 4 >::Use | use,
|  | void * | useArgs = `0`
| ) |  |

static

Constructs a search manager of the best possible class for the given search parameters.

Different subclasses of GluingPermSearcher<4> provide optimised search algorithms for different types of search.

Calling this routine and then calling runSearch() on the result has the same effect as the all-in-one routine findAllPerms(). Unless you have specialised requirements (such as partial searching), you are probably better calling findAllPerms() instead.

The resulting object is newly created, and must be destroyed by the caller of this routine.

See the GluingPermSearcher<4> constructor for documentation on the arguments to this routine.

Precondition
  The given facet pairing is connected, i.e., it is possible to reach any pentachoron from any other pentachoron via a series of matched facet pairs.
  The given facet pairing is in canonical form as described by FacetPairing<4>::isCanonical(). Note that all facet pairings constructed by FacetPairing<4>::findAllPairings() are of this form.

Returns
  the newly created search manager.

## completePermSet()

bool regina::GluingPermSearcher< 4 >::completePermSet | ( |  | ) | const

inline

Determines whether this search manager holds a complete gluing permutation set or just a partially completed search state.

This may assist the use_ routine when running partial depth-based searches. See runSearch() for further details.

Returns
  `true` if a complete gluing permutation set is held, or `false` otherwise.

## dataTag()

char regina::GluingPermSearcher< 4 >::dataTag | ( |  | ) | const

inline protected virtual

Returns the character used to identify this class when storing tagged data in text format.

Returns
  the class tag.

## dumpData()

virtual void regina::GluingPermSearcher< 4 >::dumpData | ( | std::ostream & | out | ) | const

virtual

Dumps all internal data in a plain text format to the given output stream.

This object can be recreated from this text data by calling the input stream constructor for this class.

This routine may be useful for transferring objects from one processor to another.

Note that subclass data is written after superclass data, so it is safe to dump data from a subclass and then recreate a new superclass object from that data (though subclass-specific information will of course be lost).

Warning
  The data format is liable to change between Regina releases. Data in this format should be used on a short-term temporary basis only.

Parameters

  out | the output stream to which the data should be written.

Reimplemented from regina::GluingPerms< 4 >.

## dumpTaggedData()

void regina::GluingPermSearcher< 4 >::dumpTaggedData | ( | std::ostream & | out | ) | const

Dumps all internal data in a plain text format, along with a marker to signify which precise class the data belongs to.

This routine can be used with readTaggedData() to transport objects from place to place whose precise class is unknown.

Warning
  The data format is liable to change between Regina releases. Data in this format should be used on a short-term temporary basis only.

Parameters

  out | the output stream to which the data should be written.

## edgeBdryBackup()

void regina::GluingPermSearcher< 4 >::edgeBdryBackup | ( | int | edgeID | ) |

inline protected

Copies the bdryNext and bdryTwist arrays to the bdryNextOld and bdryTwistOld arrays for the given pentachoron edge.

See the PentEdgeState class for further information.

Parameters

  edgeID | the pentachoron edge on which to operate; this must be between 0 and 10n-1 inclusive, where n is the number of pentachora.

## edgeBdryConsistencyCheck()

void regina::GluingPermSearcher< 4 >::edgeBdryConsistencyCheck | ( |  | ) |

protected

Runs a number of tests on all pentachoron edges to locate consistency errors in the bdryEdges, bdryNext and bdryTwist members of the PentEdgeState class.

Any errors that are identified will be written to standard error. Note that some errors might be harmless (for instance, when a call to mergeEdgeClasses() leaves processing incomplete because it has located a bad edge link and expects the merge to be immediately undone).

## edgeBdryDump()

void regina::GluingPermSearcher< 4 >::edgeBdryDump | ( | std::ostream & | out | ) |

protected

Dumps a summary of bdryNext, bdryTwist and bdryEdges for every edge of every pentachoron to the given output stream.

The output format is relatively compact, and is subject to change in future versions of Regina. The output uses one line only, and a final newline is written.

See the PentEdgeState class for further information.

Parameters

  out | the output stream to which to write.

## edgeBdryFixAdj()

void regina::GluingPermSearcher< 4 >::edgeBdryFixAdj | ( | int | edgeID | ) |

inline protected

Adjusts the bdryNext and bdryTwist arrays for nearby pentachoron edges, to ensure that these arrays are consistent with the bdryNext and bdryTwist arrays stored with the given pentachoron edge.

It is assumed that the linking triangle for the given pentachoron edge contributes at least one boundary edge to the 4-manifold edge link. Recall from the PentEdgeState class notes that the bdryNext and bdryTwist arrays for the given pentachoron edge describe the boundary edges that follow on in either direction from the boundary edges supplied by this triangle.

This routine locates the pentachoron edges that provide the neighbouring boundary edges of the link, and adjusts the bdryNext and bdryTwist arrays for these neighbouring pentachoron edges to point back to the given pentachoron edge.

This routine is intended to assist with backtracking. This routine is safe to use if the given pentachoron edge points to itself (i.e., it provides a complete boundary cycle of three edges in the 4-manifold edge link).

See the PentEdgeState class for further information.

Precondition
  The linking triangle for the given pentachoron edge contributes at least one boundary edge to the 4-manifold edge link.

Parameters

  edgeID | the pentachoron edge to examine; this must be between 0 and 10n-1 inclusive, where n is the number of pentachora.

## edgeBdryJoin()

void regina::GluingPermSearcher< 4 >::edgeBdryJoin | ( | int | edgeID,
|  | char | end,
|  | int | adjEdgeID,
|  | char | twist
| ) |  |

inline protected

Signifies that the boundary edges supplied by the linking triangles for the two given pentachoron edges should be marked as adjacent.

The bdryNext and bdryTwist arrays for each pentachoron edge will be adjusted to point to the other.

See the PentEdgeState class for details.

Parameters

  edgeID | the first pentachoron edge on which to operate; this must be between 0 and 10n-1 inclusive, where n is the number of pentachora.
  end | specifies in which direction the adjacent boundary edges lie. This must be either 0 or 1, and its value should correspond to the relevant index in the bdryNext and bdryTwist arrays for edge edgeID.
  adjEdgeID | the pentachoron edge whose boundary edges are adjacent to the boundary edges supplied by edgeID; this must be between 0 and 10n-1 inclusive, where n is the number of pentachora.
  twist | 0 if the orientations of the two boundary segments of edge link are oriented in the same direction, or 1 if they are oriented in opposite directions; see the bdryTwist documentation for details.

## edgeBdryLength1()

bool regina::GluingPermSearcher< 4 >::edgeBdryLength1 | ( | int | edgeID | ) |

inline protected

Determines whether one of the edges of the linking triangle for the given pentachoron edge in fact forms an entire one-edge boundary component of the overall 4-manifold edge link.

See the PentEdgeState class for further information.

Parameters

  edgeID | the pentachoron edge to examine; this must be between 0 and 10n-1 inclusive, where n is the number of pentachora.

Returns
  `true` if a one-edge boundary component is formed as described above, or `false` otherwise.

## edgeBdryLength2()

bool regina::GluingPermSearcher< 4 >::edgeBdryLength2 | ( | int | edgeID1,
|  | int | edgeID2
| ) |  |

inline protected

Determines whether edges of the linking triangles for each of the given pentachoron edges combine to form an entire two-edge boundary component of the overall 4-manifold edge link, with one edge from each triangle.

See the PentEdgeState class for further information.

Parameters

  edgeID1 | the first pentachoron edge to examine; this must be between 0 and 10n-1 inclusive, where n is the number of pentachora.
  edgeID2 | the second pentachoron edge to examine; this must be between 0 and 10n-1 inclusive, where n is the number of pentachora.

Returns
  `true` if a two-edge boundary component is formed as described above, or `false` otherwise.

## edgeBdryNext()

void regina::GluingPermSearcher< 4 >::edgeBdryNext | ( | int | edgeID,
|  | int | pent,
|  | int | edge,
|  | int | bdryFacet,
|  | int | next[2],
|  | char | twist[2]
| ) |  |

protected

Assuming the given edge of the linking triangle for the given pentachoron edge lies on the boundary of the link, this routine identifies the adjacent boundary edges of the link in each direction.

The given edge of the linking triangle must belong to one of the two pentachoron facets currently being joined.

The pentachoron edge to examine is passed in edgeID, pent and edge, and the particular edge of the linking triangle to examine is specified by bdryFacet. Details of the adjacent boundary edges are returned in the arrays next and twist.

Note that the values returned might or might not correspond to the bdryNext and bdryTwist arrays of the PentEdgeState class, since the PentEdgeState arrays skip over adjacent edges belonging to the same linking triangle.

If the given edge of the linking triangle is not a boundary edge of the 4-manifold edge link, the behaviour of this routine is undefined.

See the PentEdgeState class for further information.

Precondition
  The pentachoron facet (pent, bdryFacet) is one of the two facets that are currently being joined together. That is, this facet is either order_[orderElt_] or its partner in the underlying pentachoron facet pairing.

Parameters

  edgeID | the pentachoron edge to examine; this must be between 0 and 10n-1 inclusive, where n is the number of pentachora.
  pent | the pentachoron described by edgeID; this must be (edgeID / 10). It is passed separately to avoid a slow division operation.
  edge | the pentachoron edge number described by edgeID; this must be (edgeID % 10). It is passed separately to avoid a slow modulus operation.
  bdryFacet | the facet number of the given pentachoron containing the edge of the linking triangle that is under consideration. This must be between 0 and 4 inclusive.
  next | returns the pentachoron edge supplying each adjacent boundary edge of the link; see the PentEdgeState::bdryNext notes for details on which directions correspond to array indices 0 and 1.
  twist | returns whether the orientations of the adjacent boundary edges are consistent with the orientation of this boundary edge; see the PentEdgeState::bdryTwist notes for further information on orientations in the link.

## edgeBdryRestore()

void regina::GluingPermSearcher< 4 >::edgeBdryRestore | ( | int | edgeID | ) |

inline protected

Copies the bdryNextOld and bdryTwistOld arrays to the bdryNext and bdryTwist arrays for the given pentachoron edge.

See the PentEdgeState class for further information.

Parameters

  edgeID | the pentachoron edge on which to operate; this must be between 0 and 10n-1 inclusive, where n is the number of pentachora.

## facetPairing()

const FacetPairing< dim > * regina::GluingPerms< dim >::facetPairing | ( |  | ) | const

inline inherited

Returns the specific pairing of simplex facets that this set of gluing permutations complements.

Returns
  the corresponding simplex facet pairing.

## findAllPerms()

static void regina::GluingPermSearcher< 4 >::findAllPerms | ( | const FacetPairing< 4 > * | pairing,
|  | const FacetPairing< 4 >::IsoList * | autos,
|  | bool | orientableOnly,
|  | bool | finiteOnly,
|  | GluingPermSearcher< 4 >::Use | use,
|  | void * | useArgs = `0`
| ) |  |

static

The main entry routine for running a search for all gluing permutation sets that complement a given pentachoron facet pairing.

This routine examines the search parameters, chooses the best possible search algorithm, constructs an object of the corresponding subclass of GluingPermSearcher<4> and then calls runSearch().

See the GluingPermSearcher<4> constructor for documentation on the arguments to this routine. See the runSearch() method for documentation on how the search runs and returns its results.

Precondition
  The given facet pairing is connected, i.e., it is possible to reach any pentachoron from any other pentachoron via a series of matched facet pairs.
  The given facet pairing is in canonical form as described by FacetPairing<4>::isCanonical(). Note that all facet pairings constructed by FacetPairing<4>::findAllPairings() are of this form.

## findTriangleClass() [1/2]

int regina::GluingPermSearcher< 4 >::findTriangleClass | ( | int | triID | ) | const

inline protected

Returns the representative of the equivalence class containing the given pentachoron triangle.

The class representative is defined to be the root of the corresponding union-find tree.

See the PentTriangleState class for further details. See also the other variant of findTriangleClass(), which is slower but which also tracks triangle rotations and reflections.

Parameters

  triID | the index of a single pentachoron triangle; this must be between 0 and 10p-1 inclusive, where p is the number of pentachora. See the PentTriangleState class notes for details on triangle indexing.

Returns
  the index of the pentachoron triangle at the root of the union-find tree, i.e., the representative of the equivalence class.

## findTriangleClass() [2/2]

int regina::GluingPermSearcher< 4 >::findTriangleClass | ( | int | triID,
|  | Perm< 3 > & | twist
| ) |  | const

inline protected

Returns the representative of the equivalence class containing the given pentachoron triangle.

The class representative is defined to be the root of the corresponding union-find tree.

The argument twist is also modified to indicate what rotation or reflection is used to identify vertices (0,1,2) of the given triangle with vertices (0,1,2) of the class representative. Note that this argument is not initialised. Instead, the original twist will be multiplied on the left by the mapping described above.

See the PentTriangleState class for further details. See also the other variant of findTriangleClass(), which is faster but which does not track triangle rotations and reflections.

Parameters

  triID | the index of a single pentachoron triangle; this must be between 0 and 10p-1 inclusive, where p is the number of pentachora. See the PentTriangleState class notes for details on triangle indexing.
  twist | used to track triangle rotations and reflections, as described above. This must be a mapping from (0,1,2) to (0,1,2) as it is passed into the function, and it will also be a mapping from (0,1,2) to (0,1,2) upon returning from the function.

Returns
  the index of the pentachoron triangle at the root of the union-find tree, i.e., the representative of the equivalence class.

## gluingPerm() [1/2]

Perm< dim+1 > regina::GluingPerms< dim >::gluingPerm | ( | const FacetSpec< dim > & | source | ) | const

inline inherited

Returns the gluing permutation associated with the given simplex facet.

Precondition
  The given facet is actually paired with some other facet in the underlying pairwise matching (see routine facetPairing()).
  The given facet is a real simplex facet (not boundary, before-the-start or past-the-end).

Parameters

  source | the simplex facet under investigation.

Returns
  the associated gluing permutation.

## gluingPerm() [2/2]

Perm< dim+1 > regina::GluingPerms< dim >::gluingPerm | ( | unsigned | simp,
|  | unsigned | facet
| ) |  | const

inline inherited

Returns the gluing permutation associated with the given simplex facet.

Precondition
  The given facet is actually paired with some other facet in the underlying pairwise matching (see routine facetPairing()).

Parameters

  simp | the simplex under investigation (this must be strictly less than the total number of simplices under consideration).
  facet | the facet of the given simplex under investigation (between 0 and dim inclusive).

Returns
  the associated gluing permutation.

## gluingToIndex() [1/2]

int regina::GluingPerms< dim >::gluingToIndex | ( | const FacetSpec< dim > & | source,
|  | const Perm< dim+1 > & | gluing
| ) |  | const

protected inherited

Returns the index into array Perm<dim+1>::Sn_1 corresponding to the given gluing permutation from the given facet to its partner.

This need not be the index into Perm<dim+1>::Sn_1 that is currently stored for the given facet.

Indices into array Perm<dim+1>::Sn_1 are stored internally in the array permIndices_. Full gluing permutations on the other hand are used in constructing triangulations.

Precondition
  The given simplex facet has a partner according to the underlying facet pairing, i.e., is not a boundary facet.
  If the given simplex facet and its partner are facets x and y of their respective simplices, then the given gluing permutation maps x to y.

Parameters

  source | the simplex facet under investigation.
  gluing | a possible gluing permutation from the given simplex facet to its partner according to the underlying facet pairing.

Returns
  the index into Perm<dim+1>::Sn_1 corresponding to the given gluing permutation; this will be between 0 and dim!-1 inclusive.

## gluingToIndex() [2/2]

int regina::GluingPerms< dim >::gluingToIndex | ( | unsigned | simp,
|  | unsigned | facet,
|  | const Perm< dim+1 > & | gluing
| ) |  | const

protected inherited

Returns the index into array Perm<dim+1>::Sn_1 corresponding to the given gluing permutation from the given facet to its partner.

This need not be the index into Perm<dim+1>::Sn_1 that is currently stored for the given facet.

Indices into array Perm<dim+1>::Sn_1 are stored internally in the array permIndices_. Full gluing permutations on the other hand are used in constructing triangulations.

Precondition
  The given simplex facet has a partner according to the underlying facet pairing, i.e., is not a boundary facet.
  If the given simplex facet and its partner are facets x and y of their respective simplices, then the given gluing permutation maps x to y.

Parameters

  simp | the simplex under investigation; this must be strictly less than the total number of simplices under consideration.
  facet | the facet of the given simplex under investigation; this must be between 0 and dim inclusive.
  gluing | a possible gluing permutation from the given simplex facet to its partner according to the underlying facet pairing.

Returns
  the index into Perm<dim+1>::Sn_1 corresponding to the given gluing permutation; this will be between 0 and dim!-1 inclusive.

## indexToGluing() [1/2]

Perm< dim+1 > regina::GluingPerms< dim >::indexToGluing | ( | const FacetSpec< dim > & | source,
|  | int | index
| ) |  | const

inline protected inherited

Returns the gluing permutation from the given facet to its partner that corresponds to the given index into array Perm<dim+1>::Sn_1.

This index into Perm<dim+1>::Sn_1 need not be the index that is currently stored for the given facet.

Indices into array Perm<dim+1>::Sn_1 are stored internally in the array permIndices_. Full gluing permutations on the other hand are used in constructing triangulations.

If the given simplex facet and its partner according to the underlying facet pairing are facets x and y of their respective simplices, then the resulting gluing permutation will map x to y.

Precondition
  The given simplex facet has a partner according to the underlying facet pairing, i.e., is not a boundary facet.

Parameters

  source | the simplex facet under investigation.
  index | an index into Perm<dim+1>::Sn_1; this must be between 0 and dim!-1 inclusive.

Returns
  the gluing permutation corresponding to the given index into Perm<dim+1>::Sn_1.

## indexToGluing() [2/2]

Perm< dim+1 > regina::GluingPerms< dim >::indexToGluing | ( | unsigned | simp,
|  | unsigned | facet,
|  | int | index
| ) |  | const

inline protected inherited

Returns the gluing permutation from the given facet to its partner that corresponds to the given index into array Perm<dim+1>::Sn_1.

This index into Perm<dim+1>::Sn_1 need not be the index that is currently stored for the given facet.

Indices into array Perm<dim+1>::Sn_1 are stored internally in the array permIndices_. Full gluing permutations on the other hand are used in constructing triangulations.

If the given simplex facet and its partner according to the underlying facet pairing are facets x and y of their respective simplices, then the resulting gluing permutation will map x to y.

Precondition
  The given simplex facet has a partner according to the underlying facet pairing, i.e., is not a boundary facet.

Parameters

  simp | the simplex under investigation; this must be strictly less than the total number of simplices under consideration.
  facet | the facet of the given simplex under investigation; this must be between 0 and dim inclusive.
  index | an index into Perm<dim+1>::Sn_1; this must be between 0 and dim!-1 inclusive.

Returns
  the gluing permutation corresponding to the given index into Perm<dim+1>::Sn_1.

## inputError()

bool regina::GluingPerms< dim >::inputError | ( |  | ) | const

inline inherited

Was an error found during construction from an input stream?

This routine returns `true` if an input stream constructor was used to create this object but the data in the input stream was invalid or incorrectly formatted.

If a different constructor was called (i.e., no input stream was used), then this routine will always return `false`.

Returns
  `true` if an error occurred during construction from an input stream, or `false` otherwise.

## isCanonical()

bool regina::GluingPermSearcher< 4 >::isCanonical | ( |  | ) | const

protected

Compares the current set of gluing permutations with its preimage under each automorphism of the underlying facet pairing, in order to see whether the current set is in canonical form (i.e., is lexicographically smallest).

Returns
  `true` if the current set is in canonical form, or `false` otherwise.

## mergeEdgeClasses()

bool regina::GluingPermSearcher< 4 >::mergeEdgeClasses | ( |  | ) |

protected

Merges the classes of pentachoron edges as required by the new gluing made at stage orderElt of the search.

See the PentEdgeState class for details.

This routine returns a boolean that indicates whether this merge creates an invalid edge (i.e., an edge with identified with itself in reverse, or whose link is something other than a (possibly) punctured 2-sphere).

Returns
  `true` if this merge creates an invalid edge, or `false` if not.

## mergeTriangleClasses()

bool regina::GluingPermSearcher< 4 >::mergeTriangleClasses | ( |  | ) |

protected

Merges the classes of pentachoron triangles as required by the new gluing made at stage orderElt of the search.

See the PentTriangleState class for details.

This routine returns a boolean that indicates whether this merge creates an invalid triangle (i.e., a triangle identified with itself using a non-trivial rotation or reflection).

Returns
  `true` if this merge creates an invalid triangle, or `false` if not.

## permIndex() [1/4]

int & regina::GluingPerms< dim >::permIndex | ( | const FacetSpec< dim > & | source | ) |

inline protected inherited

Returns the index into array Perm<dim+1>::Sn_1 describing how the the given facet is joined to its partner.

Note that this permutation is not a gluing permutation as such, but rather a permutation of 0,...,dim-1 only. For a real facet gluing permutation, see routine gluingPerm().

Precondition
  The given facet is a real simplex facet (not boundary, before-the-start or past-the-end).

Parameters

  source | the simplex facet under investigation.

Returns
  a reference to the corresponding array index.

## permIndex() [2/4]

int & regina::GluingPerms< dim >::permIndex | ( | unsigned | simp,
|  | unsigned | facet
| ) |  |

inline protected inherited

Returns the index into array Perm<dim+1>::Sn_1 describing how the the given facet is joined to its partner.

Note that this permutation is not a gluing permutation as such, but rather a permutation of 0,...,dim-1 only. For a real facet gluing permutation, see routine gluingPerm().

Parameters

  simp | the simplex under investigation (this must be strictly less than the total number of simplices under consideration).
  facet | the facet of the given simplex under investigation (between 0 and dim inclusive).

Returns
  a reference to the corresponding array index.

## permIndex() [3/4]

const int & regina::GluingPerms< dim >::permIndex | ( | const FacetSpec< dim > & | source | ) | const

inline protected inherited

Returns the index into array Perm<dim+1>::Sn_1 describing how the the given facet is joined to its partner.

Note that this permutation is not a gluing permutation as such, but rather a permutation of 0,...,dim-1 only. For a real facet gluing permutation, see routine gluingPerm().

Precondition
  The given facet is a real simplex facet (not boundary, before-the-start or past-the-end).

Parameters

  source | the simplex facet under investigation.

Returns
  a reference to the corresponding array index.

## permIndex() [4/4]

const int & regina::GluingPerms< dim >::permIndex | ( | unsigned | simp,
|  | unsigned | facet
| ) |  | const

inline protected inherited

Returns the index into array Perm<dim+1>::Sn_1 describing how the the given facet is joined to its partner.

Note that this permutation is not a gluing permutation as such, but rather a permutation of 0,...,dim-1 only. For a real facet gluing permutation, see routine gluingPerm().

Parameters

  simp | the simplex under investigation (this must be strictly less than the total number of simplices under consideration).
  facet | the facet of the given simplex under investigation (between 0 and dim inclusive).

Returns
  a reference to the corresponding array index.

## readTaggedData()

static GluingPermSearcher<4>* regina::GluingPermSearcher< 4 >::readTaggedData | ( | std::istream & | in,
|  | GluingPermSearcher< 4 >::Use | use,
|  | void * | useArgs = `0`
| ) |  |

static

Creates a new search manager based on tagged data read from the given input stream.

This may be a new search or a partially completed search.

The tagged data should be in the format written by dumpTaggedData(). The precise class of the search manager will be determined from the tagged data, and does not need to be known in advance. This is in contrast to dumpData() and the input stream constructors, where the class of the data being read must be known at compile time.

If the data found in the input stream is invalid or incorrectly formatted, a null pointer will be returned. Otherwise a newly constructed search manager will be returned, and it is the responsibility of the caller of this routine to destroy it after use.

The arguments use and useArgs are the smae as for the GluingPermSearcher<4> constructor.

Warning
  The data format is liable to change between Regina releases. Data in this format should be used on a short-term temporary basis only.

Parameters

  in | the input stream from which to read.

## runSearch()

virtual void regina::GluingPermSearcher< 4 >::runSearch | ( | long | maxDepth = `-1` | ) |

virtual

Generates all possible gluing permutation sets that satisfy the current search criteria.

The search criteria are specified in the class constructor, or through the static method findAllPerms().

Each set of gluing permutations will be produced precisely once up to equivalence, where equivalence is defined by the given set of automorphisms of the given facet pairing.

For each permutation set that is generated, routine use_ (as passed to the class constructor) will be called with that permutation set as an argument.

Once the generation of permutation sets has finished, routine use_ will be called once more, this time with `null` as its first (permutation set) argument.

Subclasses corresponding to more specialised search criteria should override this routine to use a better optimised algorithm where possible.

It is possible to run only a partial search, branching to a given depth but no further. In this case, rather than producing complete gluing permutation sets, the search will produce a series of partially-complete GluingPermSearcher<4> objects. These partial searches may then be restarted by calling runSearch() once more (usually after being frozen or passed on to a different processor). If necessary, the use_ routine may call completePermSet() to distinguish between a complete set of gluing permutations and a partial search state.

Note that a restarted search will never drop below its initial depth. That is, calling runSearch() with a fixed depth can be used to subdivide the overall search space into many branches, and then calling runSearch() on each resulting partial search will complete each of these branches without overlap.

Todo:
  Feature: Allow cancellation of permutation set generation.

Parameters

  maxDepth | the depth of the partial search to run, or a negative number if a full search should be run (the default).

## size()

unsigned regina::GluingPerms< dim >::size | ( |  | ) | const

inline inherited

Returns the total number of simplices under consideration.

Returns
  the number of simplices under consideration.

## splitEdgeClasses()

void regina::GluingPermSearcher< 4 >::splitEdgeClasses | ( |  | ) |

protected

Splits the classes of pentachoron edges to mirror the undoing of the gluing at stage orderElt of the search.

See the PentEdgeState class for details.

## splitTriangleClasses()

void regina::GluingPermSearcher< 4 >::splitTriangleClasses | ( |  | ) |

protected

Splits the classes of pentachoron triangles to mirror the undoing of the gluing at stage orderElt of the search.

See the PentTriangleState class for details.

## triangulate()

Triangulation<dim>* regina::GluingPerms< dim >::triangulate | ( |  | ) | const

inherited

Returns a newly created triangulation as modelled by this set of gluing permutations and the associated simplex facet pairing.

Each matched pair of facets and their associated permutations will be realised as two simplex facets in the triangulation glued together with the corresponding gluing permutation. Each unmatched facet will be realised as a boundary facet in the triangulation.

It is the responsibility of the caller of this routine to delete this triangulation once it is no longer required.

Returns
  a newly created triangulation modelled by this structure.

## Member Data Documentation

## autos_

const FacetPairing<4>::IsoList* regina::GluingPermSearcher< 4 >::autos_

protected

The set of isomorphisms that define equivalence of gluing permutation sets.

Generally this is the set of all automorphisms of the underlying facet pairing.

## autosNew_

bool regina::GluingPermSearcher< 4 >::autosNew_

protected

Did we create the isomorphism list autos_ ourselves (in which case we must destroy it also)?

## dataTag_

const char regina::GluingPermSearcher< 4 >::dataTag_

static

A character used to identify this class when reading and writing tagged data in text format.

## edgeLinkNextFacet

const int regina::GluingPermSearcher< 4 >::edgeLinkNextFacet[10][5]

static protected

Maintains an ordering of the three pentachoron facets surrounding an edge in a pentachoron.

This ordering is consistent with the orientations of triangles in the edge link used by PentEdgeState::twistUp.

For edge e (0..9), the pentachoron facet that follows f (0..5) in this ordering is edgeLinkNextFacet[e][f]. Note that 2/5 of the values in this array remain unaccounted for; these remaining values are set to -1.

## edgeLinkPrevFacet

const int regina::GluingPermSearcher< 4 >::edgeLinkPrevFacet[10][5]

static protected

Provides backwards links for the ordering described by edgeLinkNextFacet.

For edge e (0..9), the pentachoron facet that follows f (0..5) in this ordering is edgeLinkPrevFacet[e][f]. Again 2/5 of the values in this array remain unaccounted for, and these remaining values are set to -1.

## edgeState_

PentEdgeState* regina::GluingPermSearcher< 4 >::edgeState_

protected

Used for tracking equivalence classes of identified pentachoron edges.

See the PentEdgeState description for details. This array has size 10n, where edge e of pentachoron p has index 10p+e.

## edgeStateChanged_

int* regina::GluingPermSearcher< 4 >::edgeStateChanged_

protected

Tracks the way in which the edgeState_[] array has been updated over time.

This array has size 25n. Suppose the gluing for order[i] affects facet k of pentachoron p. Then element 10i+e of this array describes how the gluing for order[i] affects edge e of pentachoron p. Note that almost half of this array will remain unused, since only six edges of a pentachoron are affected by any one gluing.

If this identification of edges results in the tree with root edgeState_[x] being grafted beneath the tree with root edgeState_[y], this array will store the value x. Otherwise it will store the value -1.

## finiteOnly_

bool regina::GluingPermSearcher< 4 >::finiteOnly_

protected

Are we only searching for gluing permutations that correspond to finite (non-ideal) triangulations?

## inputError_

bool regina::GluingPerms< dim >::inputError_

protected inherited

Has an error occurred during construction from an input stream?

## nEdgeClasses_

unsigned regina::GluingPermSearcher< 4 >::nEdgeClasses_

protected

The number of equivalence classes of identified pentachoron edges.

## nTriangleClasses_

unsigned regina::GluingPermSearcher< 4 >::nTriangleClasses_

protected

The number of equivalence classes of identified pentachoron triangles.

## order_

FacetSpec<4>* regina::GluingPermSearcher< 4 >::order_

protected

Describes the order in which gluing permutations are assigned to pentachoron facets.

Specifically, this order is order_[0], order_[1], ..., order_[orderSize_-1].

Note that each element of this array corresponds to a single edge of the underlying facet pairing graph, which in turn represents a pentachoron facet and its image under the given facet pairing.

The specific pentachoron facet stored in this array for each edge of the underlying facet pairing graph will be the smaller of the two identified pentachoron facets.

## orderElt_

int regina::GluingPermSearcher< 4 >::orderElt_

protected

Marks which element of order_[] we are currently examining at this stage of the search.

## orderSize_

int regina::GluingPermSearcher< 4 >::orderSize_

protected

The total number of edges in the facet pairing graph, i.e., the number of elements of interest in the order_[] array.

## orientableOnly_

bool regina::GluingPermSearcher< 4 >::orientableOnly_

protected

Are we only searching for gluing permutations that correspond to orientable triangulations?

## orientation_

int* regina::GluingPermSearcher< 4 >::orientation_

protected

Keeps track of the orientation of each pentachoron in the underlying triangulation.

Orientation is positive/negative, or 0 if unknown. Note that in some algorithms the orientation is simply +/-1, and in some algorithms the orientation counts forwards or backwards from 0 according to how many times the orientation has been set or verified.

## pairing_

const FacetPairing<dim>* regina::GluingPerms< dim >::pairing_

protected inherited

The facet pairing that this permutation set complements.

This is guaranteed to be the minimal representative of its facet pairing isomorphism class.

## permIndices_

int* regina::GluingPerms< dim >::permIndices_

protected inherited

The index into array Perm<dim+1>::Sn_1 describing how each simplex facet is glued to its partner.

Note that this is not a gluing permutation as such but rather a permutation of 0,...,dim-1 only (see the routines gluingToIndex() and indexToGluing() for conversions). If a permutation has not yet been selected (e.g., if this permutation set is still under construction) then this index is -1.

## started_

bool regina::GluingPermSearcher< 4 >::started_

protected

Has the search started yet? This helps distinguish between a new search and the resumption of a partially completed search.

## triState_

PentTriangleState* regina::GluingPermSearcher< 4 >::triState_

protected

Used for tracking equivalence classes of identified pentachoron triangles.

See the PentTriangleState description for details. This array has size 10n, where triangle f of pentachoron p has index 10p+f.

## triStateChanged_

int* regina::GluingPermSearcher< 4 >::triStateChanged_

protected

Tracks the way in which the triState_[] array has been updated over time.

This array has size [25n/2]. Suppose the gluing for order[i] affects facet k of pentachoron p. Then element 5i+v of this array describes how the gluing for order[i] affects the triangle of pentachoron p opposite vertices k and v (note that a fifth of this array will remain unused, since k and v are never equal).

If this identification of triangles results in the tree with root triState_[x] being grafted beneath the tree with root triState_[y], this array will store the value x. Otherwise it will store the value -1.

## use_

GluingPermSearcher<4>::Use regina::GluingPermSearcher< 4 >::use_

protected

A routine to call each time a gluing permutation set is found during the search.

## useArgs_

void* regina::GluingPermSearcher< 4 >::useArgs_

protected

Additional user-supplied data to be passed as the second argument to the use_ routine.

The documentation for this class was generated from the following file:

- census/gluingpermsearcher4.h

Copyright © 1999-2016, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@maths.uq.edu.au).